-- Migrate an Xbus database from version 3.0.0-beta.2 to 3.0.0-beta.3.

-- Adjust the actor table.

ALTER TABLE actor DROP CONSTRAINT u_actor_name_type;

ALTER TABLE actor ADD CONSTRAINT u_actor_name UNIQUE(name);

ALTER TABLE actor RENAME COLUMN type TO kind;

-- The type of the "emission.event_positions" has changed.

ALTER TABLE emission ALTER COLUMN event_positions TYPE text;

-- Create a new log_entry table (copy-paste from pgadmin).

CREATE SEQUENCE log_entry_id_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE log_entry_id_seq
  OWNER TO xbus_nats;

CREATE TABLE log_entry
(
  node_id character varying(255) NOT NULL,
  "time" timestamp without time zone NOT NULL,
  level character varying(255) NOT NULL,
  text text NOT NULL,
  id bigint NOT NULL DEFAULT nextval('log_entry_id_seq'::regclass),
  envelope_id uuid,
  actor_id uuid,
  process_id uuid,
  CONSTRAINT log_entry_pkey PRIMARY KEY (id),
  CONSTRAINT log_entry_actor_id_fkey FOREIGN KEY (actor_id)
      REFERENCES actor (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT log_entry_envelope_id_fkey FOREIGN KEY (envelope_id)
      REFERENCES envelope (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE log_entry
  OWNER TO xbus_nats;

CREATE INDEX i_envelope_id_actor_id
  ON log_entry
  USING btree
  (envelope_id, actor_id);
