package model

// generated with yago. Better NOT to edit!

import (
	"database/sql"
	"fmt"
	"reflect"

	"github.com/slicebit/qb"

	"github.com/m4rw3r/uuid"
	"github.com/orus-io/yago"
)

const (
	// AccountName is the Name field name
	AccountName = "Name"
	// AccountNameColumnName is the Name field associated column name
	AccountNameColumnName = "name"
	// AccountType is the Type field name
	AccountType = "Type"
	// AccountTypeColumnName is the Type field associated column name
	AccountTypeColumnName = "type"
	// AccountStatus is the Status field name
	AccountStatus = "Status"
	// AccountStatusColumnName is the Status field associated column name
	AccountStatusColumnName = "status"
	// AccountCSR is the CSR field name
	AccountCSR = "CSR"
	// AccountCSRColumnName is the CSR field associated column name
	AccountCSRColumnName = "csr"
	// AccountCSROrigin is the CSROrigin field name
	AccountCSROrigin = "CSROrigin"
	// AccountCSROriginColumnName is the CSROrigin field associated column name
	AccountCSROriginColumnName = "csr_origin"
	// AccountCert is the Cert field name
	AccountCert = "Cert"
	// AccountCertColumnName is the Cert field associated column name
	AccountCertColumnName = "cert"
	// AccountAPIKey is the APIKey field name
	AccountAPIKey = "APIKey"
	// AccountAPIKeyColumnName is the APIKey field associated column name
	AccountAPIKeyColumnName = "api_key"
)

const (
	// AccountTableName is the Account associated table name
	AccountTableName = "account"
)

var accountTable = qb.Table(
	AccountTableName,
	qb.Column(AccountNameColumnName, qb.Varchar()).NotNull(),
	qb.Column(AccountTypeColumnName, qb.Varchar()).NotNull(),
	qb.Column(AccountStatusColumnName, qb.Varchar()).NotNull(),
	qb.Column(AccountCSRColumnName, qb.Text()).NotNull(),
	qb.Column(AccountCSROriginColumnName, qb.Varchar()).NotNull(),
	qb.Column(AccountCertColumnName, qb.Text()).NotNull(),
	qb.Column(AccountAPIKeyColumnName, qb.Varchar()).NotNull(),
	qb.Column(BaseIDColumnName, qb.UUID()).PrimaryKey().NotNull(),
	qb.Column(BaseCreatedAtColumnName, qb.Timestamp()).NotNull(),
	qb.Column(BaseUpdatedAtColumnName, qb.Timestamp()).Null(),
	qb.UniqueKey(
		AccountNameColumnName,
	),
)

var accountType = reflect.TypeOf(Account{})

// StructType returns the reflect.Type of the struct
// It is used for indexing mappers (and only that I guess, so
// it could be replaced with a unique identifier).
func (Account) StructType() reflect.Type {
	return accountType
}

// AccountModel provides direct access to helpers for Account
// queries
type AccountModel struct {
	mapper    *AccountMapper
	Name      yago.ScalarField
	Type      yago.MarshaledScalarField
	Status    yago.MarshaledScalarField
	CSR       yago.ScalarField
	CSROrigin yago.MarshaledScalarField
	Cert      yago.ScalarField
	APIKey    yago.ScalarField
	ID        yago.ScalarField
	CreatedAt yago.ScalarField
	UpdatedAt yago.ScalarField
}

// NewAccountModel returns a new AccountModel
func NewAccountModel(meta *yago.Metadata) AccountModel {
	mapper := NewAccountMapper()
	meta.AddMapper(mapper)
	return AccountModel{
		mapper:    mapper,
		Name:      yago.NewScalarField(mapper.Table().C(AccountNameColumnName)),
		Type:      yago.NewMarshaledScalarField(mapper.Table().C(AccountTypeColumnName)),
		Status:    yago.NewMarshaledScalarField(mapper.Table().C(AccountStatusColumnName)),
		CSR:       yago.NewScalarField(mapper.Table().C(AccountCSRColumnName)),
		CSROrigin: yago.NewMarshaledScalarField(mapper.Table().C(AccountCSROriginColumnName)),
		Cert:      yago.NewScalarField(mapper.Table().C(AccountCertColumnName)),
		APIKey:    yago.NewScalarField(mapper.Table().C(AccountAPIKeyColumnName)),
		ID:        yago.NewScalarField(mapper.Table().C(BaseIDColumnName)),
		CreatedAt: yago.NewScalarField(mapper.Table().C(BaseCreatedAtColumnName)),
		UpdatedAt: yago.NewScalarField(mapper.Table().C(BaseUpdatedAtColumnName)),
	}
}

// GetMapper returns the associated AccountMapper instance
func (m AccountModel) GetMapper() yago.Mapper {
	return m.mapper
}

// NewAccountMapper initialize a NewAccountMapper
func NewAccountMapper() *AccountMapper {
	m := &AccountMapper{}
	return m
}

// AccountMapper is the Account mapper
type AccountMapper struct{}

// GetMapper returns itself
func (mapper *AccountMapper) GetMapper() yago.Mapper {
	return mapper
}

// Name returns the mapper name
func (*AccountMapper) Name() string {
	return "model/Account"
}

// Table returns the mapper table
func (*AccountMapper) Table() *qb.TableElem {
	return &accountTable
}

// StructType returns the reflect.Type of the mapped structure
func (AccountMapper) StructType() reflect.Type {
	return accountType
}

// SQLValues returns values as a map
// The primary key is included only if having non-default values
func (mapper AccountMapper) SQLValues(instance yago.MappedStruct, fields ...string) map[string]interface{} {
	s, ok := instance.(*Account)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Account{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	allValues := len(fields) == 0
	m := make(map[string]interface{})
	if s.ID != (uuid.UUID{}) {
		m[BaseIDColumnName] = s.ID
	}
	if allValues || yago.StringListContains(fields, AccountName) {
		m[AccountNameColumnName] = s.Name
	}
	if allValues || yago.StringListContains(fields, AccountType) {
		if b, err := s.Type.MarshalText(); err == nil {
			m[AccountTypeColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, AccountStatus) {
		if b, err := s.Status.MarshalText(); err == nil {
			m[AccountStatusColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, AccountCSR) {
		m[AccountCSRColumnName] = s.CSR
	}
	if allValues || yago.StringListContains(fields, AccountCSROrigin) {
		if b, err := s.CSROrigin.MarshalText(); err == nil {
			m[AccountCSROriginColumnName] = b
		} else {
			panic(err)
		}
	}
	if allValues || yago.StringListContains(fields, AccountCert) {
		m[AccountCertColumnName] = s.Cert
	}
	if allValues || yago.StringListContains(fields, AccountAPIKey) {
		m[AccountAPIKeyColumnName] = s.APIKey
	}
	if allValues || yago.StringListContains(fields, BaseCreatedAt) {
		m[BaseCreatedAtColumnName] = s.CreatedAt
	}
	if allValues || yago.StringListContains(fields, BaseUpdatedAt) {
		m[BaseUpdatedAtColumnName] = s.UpdatedAt
	}
	return m
}

// FieldList returns the list of fields for a select
func (mapper AccountMapper) FieldList() []qb.Clause {
	return []qb.Clause{
		accountTable.C(AccountNameColumnName),
		accountTable.C(AccountTypeColumnName),
		accountTable.C(AccountStatusColumnName),
		accountTable.C(AccountCSRColumnName),
		accountTable.C(AccountCSROriginColumnName),
		accountTable.C(AccountCertColumnName),
		accountTable.C(AccountAPIKeyColumnName),
		accountTable.C(BaseIDColumnName),
		accountTable.C(BaseCreatedAtColumnName),
		accountTable.C(BaseUpdatedAtColumnName),
	}
}

// ScanPKey scans the primary key only
func (mapper AccountMapper) ScanPKey(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Account)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Account{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	return rows.Scan(
		&s.ID,
	)
}

// Scan a struct
func (mapper AccountMapper) Scan(rows *sql.Rows, instance yago.MappedStruct) error {
	s, ok := instance.(*Account)
	if !ok {
		panic(fmt.Sprintf(
			"Wrong struct type passed to the mapper. Expected &Account{}, got %s",
			reflect.TypeOf(instance).Name(),
		))
	}
	var TypeText []byte
	var StatusText []byte
	var CSROriginText []byte
	if err := rows.Scan(
		&s.Name,
		&TypeText,
		&StatusText,
		&s.CSR,
		&CSROriginText,
		&s.Cert,
		&s.APIKey,
		&s.ID,
		&s.CreatedAt,
		&s.UpdatedAt,
	); err != nil {
		return err
	}
	if err := s.Type.UnmarshalText(TypeText); err != nil {
		return err
	}
	if err := s.Status.UnmarshalText(StatusText); err != nil {
		return err
	}
	if err := s.CSROrigin.UnmarshalText(CSROriginText); err != nil {
		return err
	}
	return nil
}

// AutoIncrementPKey return true if a column of the pkey is autoincremented
func (AccountMapper) AutoIncrementPKey() bool {
	return false
}

// LoadAutoIncrementPKeyValue set the pkey autoincremented column value
func (AccountMapper) LoadAutoIncrementPKeyValue(instance yago.MappedStruct, value int64) {
	panic("Account has no auto increment column in its pkey")
}

// PKey returns the instance primary key values
func (mapper AccountMapper) PKey(instance yago.MappedStruct) (values []interface{}) {
	str := instance.(*Account)
	values = append(values, str.ID)

	return
}

// PKeyClause returns a clause that matches the instance primary key
func (mapper AccountMapper) PKeyClause(values []interface{}) qb.Clause {
	return accountTable.C(BaseIDColumnName).Eq(values[0])
}
