package main

import (
	"fmt"
	"io"
	"os"
)

func main() {
	var (
		out   io.Writer = os.Stdout
		names           = os.Args[1:]
	)

	if os.Args[1] == "-o" {
		var err error
		out, err = os.OpenFile(os.Args[2], os.O_TRUNC|os.O_CREATE|os.O_WRONLY, 0666)
		if err != nil {
			panic(err)
		}
		names = os.Args[3:]
	}
	if _, err := out.Write([]byte(head_tmpl)); err != nil {
		panic(err)
	}
	for _, name := range names {
		if _, err := fmt.Fprintf(out, enum_tmpl, name); err != nil {
			panic(err)
		}
	}
}

var (
	head_tmpl = `package api

import (
	"errors"
	"strings"
	"fmt"
)

`

	enum_tmpl = `// MarshalText serialize a %[1]s
func (e %[1]s) MarshalText() ([]byte, error) {
	s, ok := %[1]s_name[int32(e)]
	if !ok {
		return nil, fmt.Errorf("Invalid %[1]s value: %%v", e)
	}
	return []byte(s), nil
}

// UnmarshalText parses a %[1]s string
func (e *%[1]s) UnmarshalText(data []byte) error {
	value, ok := %[1]s_value[strings.ToUpper(string(data))]
	if !ok {
		return errors.New("Invalid %[1]s: " + string(data))
	}
	*e = %[1]s(value)
	return nil
}

`
)
